VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4875
   ClientLeft      =   1785
   ClientTop       =   1455
   ClientWidth     =   5415
   LinkTopic       =   "Form10"
   ScaleHeight     =   4875
   ScaleWidth      =   5415
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   1935
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   3413
      _Version        =   393217
      Style           =   7
      Appearance      =   1
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "mnuPopup"
      Visible         =   0   'False
      Begin VB.Menu mnuPopupAddNode 
         Caption         =   "&Add Node"
      End
      Begin VB.Menu mnuPopupDeleteNode 
         Caption         =   "&Delete Node"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Load a TreeView control from a file that uses tabs
' to show indentation.
Private Sub LoadTreeViewFromFile(ByVal file_name As String, ByVal trv As TreeView)
Dim fnum As Integer
Dim text_line As String
Dim level As Integer
Dim tree_nodes() As Node
Dim num_nodes As Integer

    fnum = FreeFile
    Open file_name For Input As fnum

    TreeView1.Nodes.Clear
    Do While Not EOF(fnum)
        ' Get a line.
        Line Input #fnum, text_line

        ' Find the level of indentation.
        level = 1
        Do While Left$(text_line, 1) = vbTab
            level = level + 1
            text_line = Mid$(text_line, 2)
        Loop

        ' Make room for the new node.
        If level > num_nodes Then
            num_nodes = level
            ReDim Preserve tree_nodes(1 To num_nodes)
        End If

        ' Add the new node.
        If level = 1 Then
            Set tree_nodes(level) = TreeView1.Nodes.Add(, , , text_line)
        Else
            Set tree_nodes(level) = TreeView1.Nodes.Add(tree_nodes(level - 1), tvwChild, , text_line)
            tree_nodes(level).EnsureVisible
        End If
    Loop

    Close fnum
    If trv.Nodes.Count > 0 Then trv.Nodes(1).EnsureVisible
End Sub
' Write tabs indicating this node's depth in
' the tree followed by the node's text.
' Then save its children and its siblings.
Private Sub SaveNode(ByVal fnum As Integer, ByVal n As Node, ByVal level As Integer)
    If n Is Nothing Then Exit Sub

    ' Save the node.
    Print #fnum, String$(level, vbTab) & n.Text

    ' Save its children.
    SaveNode fnum, n.Child, level + 1

    ' Save its next sibling.
    SaveNode fnum, n.Next, level
End Sub
' Save a TreeView control into a file that uses tabs
' to show indentation.
Private Sub SaveTreeViewIntoFile(ByVal file_name As String, ByVal trv As TreeView)
Dim fnum As Integer

    fnum = FreeFile
    Open file_name For Output As fnum

    ' Find the root nodes.
    If TreeView1.Nodes.Count > 0 Then SaveNode fnum, TreeView1.Nodes(1), 0

    Close fnum
End Sub

Private Sub Form_Load()
Dim file_name As String

    file_name = App.Path
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "test.txt"
    LoadTreeViewFromFile file_name, TreeView1
End Sub
Private Sub Form_Resize()
    TreeView1.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim file_name As String

    file_name = App.Path
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "test.txt"
    SaveTreeViewIntoFile file_name, TreeView1
End Sub

Private Sub mnuPopupAddNode_Click()
Dim txt As String
Dim new_node As Node

    txt = InputBox("Text", "Add Node", "")
    If Len(txt) > 0 Then
        If TreeView1.SelectedItem Is Nothing Then
            Set new_node = TreeView1.Nodes.Add(, , , txt)
        Else
            Set new_node = TreeView1.Nodes.Add( _
                TreeView1.SelectedItem, tvwChild, , txt)
        End If
        new_node.EnsureVisible
    End If
End Sub

Private Sub mnuPopupDeleteNode_Click()
    TreeView1.Nodes.Remove TreeView1.SelectedItem.Index
End Sub


Private Sub TreeView1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbRightButton Then
        Set TreeView1.SelectedItem = TreeView1.HitTest(x, y)
        PopupMenu mnuPopup
    End If
End Sub


